package {
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.b2Body;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.PreRotation;
	import net.flashpunk.graphics.Stamp;
	/**
	 * ...
	 * @author Josh Chittick
	 */
	public class Circle extends Box2DEntity
	{
		[Embed(source = 'data/Circle.png')] private static var Img:Class;
		private var img:PreRotation;
		
		public function Circle(x:int = 400, y:int = 0) 
		{
			img = new PreRotation(Img, 36);
			img.originX = img.width / 2;
			img.originY = img.height / 2;
			super(x, y, img);
			
			var scale:Number = Math.random() * 1 + 0.5;
			img.scale = scale;
			
			width = img.width;
			height = img.height;
			
			body = BodyFactory.CreateCircle(Box2DWorld(FP.world).world, this.x, this.y, 15 * scale, b2Body.b2_dynamicBody, 0.3, 1, 0.5);
			//body.SetBullet(true);
			body.SetAngularVelocity(Math.random());
		}
		
		override public function step():void
		{
			var pos:b2Vec2 = body.GetPosition();
			x = pos.x * 30 - img.width / 2 + 1;
			y = pos.y * 30 - img.height / 2 + 1;
			img.angle = -body.GetAngle() * (180 / Math.PI);
		}
		
	}

}