package  
{
	import Box2D.Common.Math.b2Vec2;
	import Box2DWorld;
	import net.flashpunk.tweens.misc.Alarm;
	import net.flashpunk.utils.Input;
	import net.flashpunk.Tween;
	import net.flashpunk.FP;
	import flash.geom.Rectangle;
	import flash.display.StageDisplayState;
	import Box2D.Dynamics.Joints.b2PulleyJoint;
	import Box2D.Dynamics.Joints.b2PulleyJointDef;
	import Box2D.Dynamics.Joints.b2PrismaticJointDef;
	
	public class Level3 extends Box2DWorld 
	{
		[Embed(source = 'data/level2bg.png')] private var Img:Class;

		private var orb:Orb;
		private var door:Box2DEntity;
		private var weight:Box2DEntity;
		private var winText:String;
		
		public function Level3(str:String)
		{
			winText = str;
		}
		
		override public function begin():void
		{
			debug_draw();
			
			add(new Background(Img));
			
			var ground:Box2DEntity = new Ground(0, 560, 800, 40);
			add(ground);
			add(new Ground(0, 0, 46, 600));
			add(new Ground(770, 0, 30, 600));
			var ceiling:Box2DEntity = new Ground(160, 0, 641, 26);
			add(ceiling);
			
			add(new Ground(46, 52, 30, 26));
			add(new Ground(160, 52, 90, 26));
			
			door = new Box(30, 27, 190, 24, 0x1c1c44);
			add(door);
			weight = new Box(300, 410, 30, 30, 0x1c1c44);
			add(weight);
			
			var jointDef:b2PulleyJointDef = new b2PulleyJointDef();
			jointDef.Initialize(door.body, weight.body, 
								new b2Vec2(door.body.GetWorldCenter().x + 10, door.body.GetWorldCenter().y),
								new b2Vec2(weight.body.GetWorldCenter().x, weight.body.GetWorldCenter().y),
								door.body.GetWorldCenter(),
								weight.body.GetWorldCenter(),
								1);
			world.CreateJoint(jointDef);
			
			var worldAxis:b2Vec2 = new b2Vec2(0, 1.0);
			var slotDef:b2PrismaticJointDef = new b2PrismaticJointDef();
			slotDef.Initialize(weight.body, ceiling.body, weight.body.GetWorldCenter(), worldAxis);
			slotDef.lowerTranslation= -5.0;
			slotDef.upperTranslation= 2.5;
			slotDef.enableLimit     = false;
			slotDef.maxMotorForce   = 1.0;
			slotDef.motorSpeed      = 0.0;
			slotDef.enableMotor     = false;
			world.CreateJoint(slotDef);
			
			add(new Box(300, 440, 30, 26));
			add(new Box(300, 470, 30, 26));
			add(new Box(300, 500, 30, 26));
			add(new Box(300, 530, 30, 26));
			
			FP.stage.fullScreenSourceRect = new Rectangle(0, 0, 800, 600);
			//FP.stage.displayState = StageDisplayState.FULL_SCREEN;	
			//FP.stage.addChild(new FPSCounter());
			orb = new Orb(50, 500, 1, 1);
			add(orb);
			FP.timeFlag();
		}
		
		override public function update():void
		{
			world.Step(1 / 30, 10, 10);
			world.ClearForces();
			
			if (orb.y < 0) {
				FP.world = new WinScreen(winText + "\nLevel3: " + (FP.timeFlag()/1000.0) + "s");
			}
			
			var tmpArr:Array = new Array();
			getClass(Box2DEntity, tmpArr);
			for each (var e:Box2DEntity in tmpArr)
			{
				e.step();
			}
			
			//world.DrawDebugData();
		}
		
	}

}