package {
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.b2Body;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.PreRotation;
	import net.flashpunk.graphics.Stamp;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;

	public class Orb extends Box2DEntity
	{
		[Embed(source = 'data/Orb.png')] private static var Img:Class;
		private var img:PreRotation;
		private var extraSpeed:b2Vec2;

		public function Orb(x:int = 400, y:int = 0, xvel:Number = 0, yvel:Number = 0) 
		{
			img = new PreRotation(Img, 36);
			img.originX = img.width / 2;
			img.originY = img.height / 2;
			super(x, y, img);
			
			var scale:Number = 1;
			img.scale = scale;
			
			width = img.width;
			height = img.height;
		
			body = BodyFactory.CreateCircle(Box2DWorld(FP.world).world, this.x, this.y, 15 * scale, b2Body.b2_dynamicBody, 0.3, 1, 0.95);
			body.SetBullet(true);
			body.SetAngularVelocity(Math.random());
			body.SetSleepingAllowed(false);
			body.SetLinearVelocity(new b2Vec2(xvel, yvel));
		}
				
		override public function step():void
		{
			var power:Number = 2;
			var motionX:Number = 0;
			var motionY:Number = 0;
			if (Input.check(Key.RIGHT)) {
				motionX = power;
			} else if (Input.check(Key.LEFT)) {
				motionX = -power;
			}

			if (Input.check(Key.UP)) {
				motionY = -power;
			} else if (Input.check(Key.DOWN)) {
				motionY = power;
			}

			var motionForce:b2Vec2 = new b2Vec2(motionX, motionY);
			
			if (body.GetLinearVelocity().y == 0) {
				motionForce.y = motionForce.y * 50;
			}
			body.ApplyForce(motionForce, body.GetWorldCenter());
			
			var pos:b2Vec2 = body.GetPosition();
			x = pos.x * 30 - img.width / 2 + 1;
			y = pos.y * 30 - img.height / 2 + 1;
			img.angle = -body.GetAngle() * (180 / Math.PI);
		}
		
	}

}