package {
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.tweens.misc.Alarm;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	/**
	 * ...
	 * @author Josh Chittick
	 */
	public class TextSplash extends Box2DWorld
	{
		private var img:Image;
		private var next:Box2DWorld;
		private var delay:Alarm;
		
		public function TextSplash(text:String, nextWorld:Box2DWorld) 
		{
			next = nextWorld;
			img = new Text(text, 0, 0, 800, 600);
		}

		override public function begin():void
		{
			add(new Entity(0, 0, img));
			delay = new Alarm(2);
			delay.active = true;
			addTween(delay, true);
		}

		override public function update():void
		{
			if (delay.remaining == 0 && (Input.mousePressed || Input.check(Key.ANY)))
			{
				FP.world = next;
			}
		}

	}
}